package edu.utk.cs.icl.perfometer.datatransfer;

import edu.utk.cs.icl.perfometer.event.PerfBreachEvent;
import edu.utk.cs.icl.perfometer.event.BreachListener;

import edu.utk.cs.icl.perfometer.metrics.MflopParser;

import com.sun.java.util.collections.*;

import java.util.StringTokenizer;

import java.net.*;
import java.io.*;
import java.text.*;
import java.lang.*;

import javax.swing.JFrame;

public class TraceFileReader extends LineReader {

  File traceFile;
  BufferedReader reader = null;

  public TraceFileReader(File f, ProcessManager p)
    throws IOException
  {
    // passing new MflopParser() is a hack... how to
    // handle the different metrics in a trace file??
    super(p, new MflopParser());
    // hostNameFull = "File: " + f.getName();
    traceFile = f;

    recycleBin = new LinkedList();
  }

  public void establishConnection()
    throws java.io.IOException
  {
    setupSockets();
    handshake(null);
  }
    
  void setupSockets() throws IOException {
    connection0 = null;
    socket0out = new DataOutputStream(new ByteArrayOutputStream(100));
    socket0in = new DataInputStream(
       new BufferedInputStream(new FileInputStream(traceFile)));
  }

  // This routine sets up the second socket that we use for output
  void setupSockets2(String host, int portNum) throws IOException {
    connection1 = null;
    socket1out = new DataOutputStream(new ByteArrayOutputStream(100));
  }

  public boolean readyToRead() throws IOException {
    if(reader == null) {
      if(socket0in == null) 
        return false;
      else
        return (socket0in.available() > 0);
    }
    else
      return reader.ready();
  }
    
  String readMessage(DataInputStream inSocket, PerfMessage m)
     throws IOException
  {
    if(DEBUG_CONNECTION)
      System.out.println("enter TraceFileReader.readMessage()");

    if(m == null)
      throw new IOException("Null message structure");

    if(reader == null)
      reader = new BufferedReader(new InputStreamReader(inSocket));

    String line = reader.readLine();

    if(DEBUG_CONNECTION) 
      System.out.println("got line: " + line);

    // hack.. why doesn't reader.readLine throw exception on eof?
    if(line == null) throw new IOException("End of file.");

    StringTokenizer st = new StringTokenizer(line);
    m.len = Integer.parseInt(st.nextToken());
    m.type = Integer.parseInt(st.nextToken());
 
    if(DEBUG_CONNECTION) System.out.println("len: " + m.len);
    if(DEBUG_CONNECTION) System.out.println("type: " + m.type);

    if(m.len > 0) {
      int i=0;

      while(!STR_DEL.equals(line.substring(i,i+1)))
        i++;

      m.msg = line.substring(i).getBytes();

      return new String(m.msg, 0, m.len);
    }

    return null;
  }

  public void disconnect() {
    stop = true;

    try {
      socket0in.close();
      socket0out.close();
      socket1out.close();
    } catch(IOException e) {
    }
  }
}
