package edu.utk.cs.icl.perfometer.metrics;

import edu.utk.cs.icl.perfometer.datatransfer.DataReader;
import edu.utk.cs.icl.perfometer.datatransfer.DataItem;
import edu.utk.cs.icl.perfometer.datatransfer.PerfProcessInfo;

import java.util.StringTokenizer;

public class GenericParser extends MetricParser {
  String [] metrics;
  String commonName = "", totalLabel = "", aggLabel = "",
     label = "", units = "";
  long num = 0;
  double total = 0.0;
  double min=Double.POSITIVE_INFINITY, max=Double.NEGATIVE_INFINITY;
 
  public MetricParser getNewInstance() {
    GenericParser g = new GenericParser();

    g.setTotalLabel(totalLabel);
    g.setAggregateLabel(aggLabel);
    g.setLabel(label);
    g.setUnits(units);
    g.setCommonName(commonName);
    g.setMetricNames(metrics);

    return g;
  }

  public void reset() {
    num = 0;
    total = 0.0;
    min=Double.POSITIVE_INFINITY;
    max=Double.NEGATIVE_INFINITY;
  }
    
  public String getMinMaxLabel() {
    return "Min/Max: ";
  }

  public String getMin() {
    return Double.toString(min);
  }

  public String getMax() {
    return Double.toString(max);
  }

  public String getTotalLabel() {
    return totalLabel;
  }
 
  public void setTotalLabel(String t) {
    totalLabel = t;
  }

  public String getAggregateLabel() {
    return aggLabel;
  }

  public void setAggregateLabel(String l) {
    aggLabel = l;
  }

  public String getLabel() {
    return label;
  }

  public void setLabel(String l) {
    label = l;
  }
 
  public String getUnits() {
    return units;
  }

  public void setUnits(String u) {
    units = u;
  }

  public String getCommonName() {
    return commonName;
  }

  public void setCommonName(String s) {
    commonName = s;
  }

  public String toString() {
    return commonName;
  }

  public String [] getMetricNames() {
    return metrics;
  }

  public void setMetricNames(String [] m) {
    metrics = m;
  }

  public void setProcInfo(PerfProcessInfo p) {
  }
  
  public void parseDATA(String s, DataItem dataItem) {
    StringTokenizer st = new StringTokenizer(s, DataReader.STR_DEL + "@");
    double value;
    int num_results, num_data;

    dataItem.rank = Integer.parseInt(st.nextToken()) - 1;
 
    num_results = Integer.parseInt(st.nextToken());
  
    for(int i = 0; i < num_results; i++) {
      // ignore # data items for now
      num_data = Integer.parseInt(st.nextToken());

      dataItem.color = Integer.parseInt(st.nextToken());
      dataItem.label = st.nextToken();

      addLabel(dataItem.rank, dataItem.color, dataItem.label);

      dataItem.s1 = st.nextToken();
      dataItem.s2 = st.nextToken();

      value = Double.valueOf(st.nextToken()).doubleValue();
      num++;

      total += value;

      dataItem.s3 = Long.toString((long)total);
      dataItem.s4 = Double.toString((int)((total/num)*100) / 100.0);

      dataItem.val = (int)(value * 100) / 100.0;

      if(dataItem.val < min) min = dataItem.val;
      if(dataItem.val > max) max = dataItem.val;
    }
  }
}
