package edu.utk.cs.icl.perfometer.metrics;

//import java.util.LinkedList;
//import java.util.ListIterator;
import com.sun.java.util.collections.*;

import java.util.Hashtable;
import java.util.Enumeration;

import edu.utk.cs.icl.perfometer.datatransfer.DataItem;
import edu.utk.cs.icl.perfometer.datatransfer.PerfProcessInfo;

import edu.utk.cs.icl.perfometer.event.GraphLegendEvent;
import edu.utk.cs.icl.perfometer.event.GraphLegendListener;

public abstract class MetricParser {
  LinkedList listeners;
  Hashtable labels;

  public MetricParser() {
    listeners = new LinkedList();
    labels = new Hashtable();
  }

  public abstract void reset();
  public abstract MetricParser getNewInstance();
  public abstract String getLabel();
  public abstract String getUnits();
  public abstract String getMinMaxLabel();
  public abstract String getMin();
  public abstract String getMax();
  public abstract String getTotalLabel();
  public abstract String getAggregateLabel();
  public abstract String getCommonName();
  public abstract String [] getMetricNames();
  public abstract void setProcInfo(PerfProcessInfo p);
  public abstract void parseDATA(String s, DataItem dataItem);

  public void addGraphLegendListener(GraphLegendListener l) {
    listeners.addLast(l);
  }

  public void removeGraphLegendListener(GraphLegendListener l) {
    listeners.remove(listeners.indexOf(l));
  }
  
  public void addLabel(int r, int c, String l) {
    if( ! labels.containsKey(l) ) {
      labels.put(l, Integer.toString(c));

      GraphLegendEvent e = new GraphLegendEvent(this,r,c,l);
      ListIterator li = listeners.listIterator(0);
      while(li.hasNext()) {
        GraphLegendListener ll = (GraphLegendListener) li.next();
        ll.labelAdded(e);
      }
    }
  }

  public Enumeration getAllLabels() {
    return labels.keys();
  }

  public Enumeration getAllColors() {
    return labels.elements();
  }
}
