package edu.utk.cs.icl.perfometer.micro_gui;

import edu.utk.cs.icl.perfometer.metrics.*;

import java.awt.Dialog;
import java.awt.Panel;
import java.awt.Choice;
import java.awt.TextField;
import java.awt.Label;
import java.awt.Button;
import java.awt.Frame;
import java.awt.FlowLayout;
import java.awt.BorderLayout;
import java.awt.Toolkit;

public class InputBox extends Dialog
{
  String hostname = "";
  int portNum = -1;
    
  Panel Panel1 = new Panel();
  TextField hostnameTxt = new TextField(28);
  Label Label1 = new Label();
  Label Label2 = new Label();
  TextField portNumTxt = new TextField(8);
  Panel Panel2 = new Panel();
  Button okBtn = new Button("OK");
  Button cancelBtn = new Button("Cancel");
  Choice metrics = new Choice();

  MetricParser [] mp = null;

  public boolean lastCancelled = false;

  InputBox(Frame owner, String title, boolean isLocalHost, MetricParser []m) {
    super(owner, title, true);

    mp = m;

    setLayout(new BorderLayout(0,0));
    setSize(240,180);

    Label1.setText("Host Name:");
    Label2.setText("Port Number:");

    hostnameTxt.setText("localhost");
    portNumTxt.setText("3545");

    for(int i=0;i<mp.length;i++)
      metrics.add(mp[i].toString());

    Panel1.setLayout(new FlowLayout(FlowLayout.LEFT,5,5));
    Panel1.add(Label1);
    Panel1.add(hostnameTxt);
    Panel1.add(Label2);
    Panel1.add(portNumTxt);
    Panel1.add(metrics);

    okBtn.setActionCommand("OK");
    cancelBtn.setActionCommand("Cancel");

    Panel2.setLayout(new FlowLayout(FlowLayout.RIGHT,5,5));
    Panel2.add(okBtn);
    Panel2.add(cancelBtn);

    add(BorderLayout.CENTER,Panel1);
    add(BorderLayout.SOUTH,Panel2);
    
    SymAction lSymAction = new SymAction();
    okBtn.addActionListener(lSymAction);
    cancelBtn.addActionListener(lSymAction);
  }
	
  public MetricParser getSelectedMetric() {
    MetricParser curMetric = null;

    try {
      curMetric = mp[metrics.getSelectedIndex()];
    } catch(Exception e) {
    }

    if(curMetric == null)
      curMetric = new MflopParser();

    return curMetric;
  }

	class SymAction implements java.awt.event.ActionListener
	{
		public void actionPerformed(java.awt.event.ActionEvent event)
		{
			Object object = event.getSource();
			if (object == okBtn)
				okBtn_actionPerformed(event);
			else if (object == cancelBtn)
				cancelBtn_actionPerformed(event);
		}
	}

	void okBtn_actionPerformed(java.awt.event.ActionEvent event)
	{
            this.lastCancelled = false;

	    try {
	        portNum = Integer.parseInt(portNumTxt.getText());
	    } catch(NumberFormatException e) {
                portNum = -1;
            }
	    
            if(hostnameTxt.getText().equalsIgnoreCase("") || (portNum == -1)) {
                Toolkit.getDefaultToolkit().beep();
            } else {
                hostname = this.hostnameTxt.getText();
                this.setVisible(false);
            	return;
            }
	}

	void cancelBtn_actionPerformed(java.awt.event.ActionEvent event)
	{
            this.lastCancelled = true;
            this.setVisible(false);
	    return;
	}
}
