package edu.utk.cs.icl.perfometer.micro_gui;

import edu.utk.cs.icl.perfometer.metrics.*;
import edu.utk.cs.icl.perfometer.datatransfer.PerfMetric;

import java.awt.Dialog;
import java.awt.Panel;
import java.awt.Choice;
import java.awt.TextField;
import java.awt.List;
import java.awt.Label;
import java.awt.Button;
import java.awt.Frame;
import java.awt.FlowLayout;
import java.awt.BorderLayout;
import java.awt.Toolkit;

public class MetricSelectionDialog extends Dialog
{
  Panel Panel1 = new Panel();
  Label Label1 = new Label();
  Panel Panel2 = new Panel();
  Button okBtn = new Button("OK");
  Button cancelBtn = new Button("Cancel");
  List metrics = new List(10,false);

  public boolean lastCancelled = false;

  MetricParser [] high;
  PerfMetric [] low;

  MetricSelectionDialog(Frame owner, MetricParser [] hi, PerfMetric [] lo) {
    super(owner, "Metric Selection", true);

    high = hi;
    low = lo;

    setLayout(new BorderLayout(0,0));
    setSize(240,295);

    Label1.setText("Select a Metric:");

    for(int i=0;i<hi.length;i++)
      metrics.add(hi[i].toString());

    for(int i=0;i<lo.length;i++) {
      if(lo[i] == null)
        break;

      metrics.add(lo[i].toString());
    }

    metrics.select(0);

    Panel1.setLayout(new BorderLayout(5,5));
    Panel1.add(BorderLayout.NORTH,Label1);
    Panel1.add(BorderLayout.CENTER,metrics);

    okBtn.setActionCommand("OK");
    cancelBtn.setActionCommand("Cancel");

    Panel2.setLayout(new FlowLayout(FlowLayout.RIGHT,5,5));
    Panel2.add(okBtn);
    Panel2.add(cancelBtn);

    add(BorderLayout.CENTER,Panel1);
    add(BorderLayout.SOUTH,Panel2);
    
    SymAction lSymAction = new SymAction();
    okBtn.addActionListener(lSymAction);
    cancelBtn.addActionListener(lSymAction);
  }
	
  public MetricParser getSelectedMetric() {
    MetricParser curMetric = null;
    int idx=-1;

    try {
      idx = metrics.getSelectedIndex();
  
      if(idx >= high.length) {
        // this must be a low-level event
        PerfMetric m = low[idx - high.length];
        GenericParser g = new GenericParser();
        g.setMetricNames(new String[]{m.getName()});
        g.setCommonName(m.getName());
        g.setLabel(m.getName());

        curMetric = g;
      }
      else {
        curMetric = high[idx];
      }

    } catch(Exception e) {
      // there will be an exception if no list item
      // is selected.
      curMetric=null;
    }

    if(curMetric == null)
      curMetric = new MflopParser();

    return curMetric;
  }

	class SymAction implements java.awt.event.ActionListener
	{
		public void actionPerformed(java.awt.event.ActionEvent event)
		{
			Object object = event.getSource();
			if (object == okBtn)
				okBtn_actionPerformed(event);
			else if (object == cancelBtn)
				cancelBtn_actionPerformed(event);
		}
	}

	void okBtn_actionPerformed(java.awt.event.ActionEvent event)
	{
            this.lastCancelled = false;
            this.setVisible(false);
            return;
	}

	void cancelBtn_actionPerformed(java.awt.event.ActionEvent event)
	{
            this.lastCancelled = true;
            this.setVisible(false);
	    return;
	}
}
