package edu.utk.cs.icl.perfometer.swing_gui;

import edu.utk.cs.icl.perfometer.event.PerfBreachEvent;

import edu.utk.cs.icl.perfometer.datatransfer.AlarmSettings;
import edu.utk.cs.icl.perfometer.datatransfer.DataReader;

import edu.utk.cs.icl.perfometer.gui_common.AudioClipPlayer;

import java.io.IOException;

import java.util.*;
import java.awt.Toolkit.*;
import java.awt.*;
import javax.swing.*;
import javax.swing.border.*;

public class AlarmBreach extends JFrame
{
  JLabel JLabel1 = new JLabel();
  JLabel headerLabel = new JLabel();
  JLabel headerLabel2 = new JLabel();

  JPanel headerPanel = new JPanel();

  JPanel valueGrid = new JPanel();

  JPanel buttonPanel = new JPanel();

  JButton okBtn = new JButton();
  JButton cancelBtn = new JButton();

  JLabel min_label = new JLabel();
  JLabel max_label = new JLabel();
  JLabel actual_label = new JLabel();

  JTextField min_value =    new JTextField("0.0",8);
  JTextField max_value =    new JTextField("0.0",8);
  JTextField actual_value = new JTextField("0.0",8);

  PerfPanel perfPanel;

  DataReader connection;

  AlarmBreach(DataReader c, PerfPanel p, PerfBreachEvent evt) {
    setTitle("Alarm Breach Report");

    setSize(220,210);
 
    perfPanel = p;
    connection = c;

    getContentPane().setLayout(new BorderLayout(5,5));

    headerPanel.setLayout(new BorderLayout(1,1));

    headerLabel.setHorizontalAlignment(SwingConstants.LEFT);
    headerLabel2.setHorizontalAlignment(SwingConstants.CENTER);

    String gLabel = perfPanel.getGraphLabel();

    AlarmSettings alset = perfPanel.getAlarmSettings();

    if(alset != null) {
      if(alset.audible) {
        if((alset.sound_url != null) && !alset.sound_url.equals(""))
        {
          AudioClipPlayer acp = AudioClipPlayer.getInstance();

          acp.setClipURL(alset.sound_url);
          acp.startClip();
        }
        else
          java.awt.Toolkit.getDefaultToolkit().beep();
      }
    }

    if(gLabel != null) {
      headerLabel.setText("Alarm Breached for: ");
      headerLabel2.setText(gLabel);
    }
    else {
      headerLabel.setText("Alarm Breached");
      headerLabel2.setText(" [process unknown] ");
    }

    headerLabel.setForeground(Color.black);
    headerLabel2.setForeground(Color.red);

    JLabel1.setHorizontalAlignment(SwingConstants.LEFT);
    JLabel1.setText("Original Alarm Settings:");

    min_label.setText("Min Value:");
    max_label.setText("Max Value:");
    actual_label.setText("Actual Value:");

    min_value.setHorizontalAlignment(JTextField.RIGHT);
    max_value.setHorizontalAlignment(JTextField.RIGHT);
    actual_value.setHorizontalAlignment(JTextField.RIGHT);

    min_value.setText(Double.toString(evt.getMin()));
    max_value.setText(Double.toString(evt.getMax()));
    actual_value.setText(Double.toString(evt.getActual()));

    min_value.setEditable(false);
    max_value.setEditable(false);
    actual_value.setEditable(false);

    valueGrid.setLayout(new GridLayout(3,2));

    valueGrid.add(min_label);
    valueGrid.add(min_value);
    valueGrid.add(max_label);
    valueGrid.add(max_value);
    valueGrid.add(actual_label);
    valueGrid.add(actual_value);
    valueGrid.setBorder(new MatteBorder(3,3,3,3,Color.darkGray));

    okBtn.setNextFocusableComponent(cancelBtn);
    okBtn.setText("Resume Graphing");
    okBtn.setActionCommand("graph");

    cancelBtn.setText("Reinstate Alarm");
    cancelBtn.setActionCommand("alarm");

    buttonPanel.setLayout(new BorderLayout(5,5));
    buttonPanel.add("North",okBtn);
    buttonPanel.add("South",cancelBtn);

    headerPanel.add("North", headerLabel);
    headerPanel.add("South", headerLabel2);

    getContentPane().add("North", headerPanel);
    getContentPane().add("Center", valueGrid);
    getContentPane().add("South", buttonPanel);

    SymAction lSymAction = new SymAction();
    okBtn.addActionListener(lSymAction);
    cancelBtn.addActionListener(lSymAction);
  }

  class SymAction implements java.awt.event.ActionListener
  {
    public void actionPerformed(java.awt.event.ActionEvent event)
    {
      Object object = event.getSource();
      if (object == okBtn)
        okBtn_actionPerformed(event);
      else if (object == cancelBtn)
        cancelBtn_actionPerformed(event);
    }
  }

  void okBtn_actionPerformed(java.awt.event.ActionEvent event)
  {
    try {
      connection.sendStart(perfPanel.getRank());
    } catch (IOException e) {
      System.err.println("Unable to send restart message." + e.getMessage());
    }
    perfPanel.clearAlarm();

    this.setVisible(false);

    return;
  }

  void cancelBtn_actionPerformed(java.awt.event.ActionEvent event)
  {
    AlarmSettings s = perfPanel.getAlarmSettings();

    try {
      connection.sendStart(perfPanel.getRank());
      connection.sendPopupParameters(perfPanel.getRank(), s.min, s.max, s.thresh, 3);
    } catch (IOException e) { 
      System.err.println("Unable to restore parameters." + e.getMessage());
    }

    this.setVisible(false);

    return;
  }
}
