package edu.utk.cs.icl.perfometer.swing_gui;

import edu.utk.cs.icl.perfometer.datatransfer.AlarmSettings;

import java.util.*;
import java.awt.Toolkit.*;
import java.awt.*;
import javax.swing.*;
import javax.swing.border.*;
import java.io.*;

public class AlarmInput extends JDialog
{
  JLabel JLabel1 = new JLabel();
  JLabel headerLabel = new JLabel();
  JLabel headerLabel2 = new JLabel();

  JFileChooser fc = new JFileChooser();

  JPanel headerPanel = new JPanel();

  JPanel panel1 = new JPanel();
  JPanel panel2 = new JPanel();
  JPanel panel3 = new JPanel();
  JPanel panel4 = new JPanel();
  JPanel panel5 = new JPanel();
  JPanel panel6 = new JPanel();
  JPanel panel7 = new JPanel();
  JPanel panel8 = new JPanel();

  JPanel inputPanel = new JPanel();
  JPanel mainPanel = new JPanel();
  JPanel audioPanel = new JPanel();
  JPanel buttonPanel = new JPanel();

  JButton okBtn = new JButton();
  JButton cancelBtn = new JButton();
  JButton chooseFileBtn = new JButton();

  JLabel min_label = new JLabel();
  JLabel max_label = new JLabel();
  JLabel thresh_label = new JLabel();

  JCheckBox selectAll_checkbox = new JCheckBox("Set for All Processes", false);
  JCheckBox sound_checkbox = new JCheckBox("Enable Audible Notification", false);
  JCheckBox beep_checkbox = new JCheckBox("Use Beep", false);
  JCheckBox url_checkbox = new JCheckBox("Use Custom Sound", false);

  JTextField min_value =    new JTextField("0.0",8);
  JTextField max_value =    new JTextField("0.0",8);
  JTextField thresh_value = new JTextField("0",8);
  JTextField url_value =    new JTextField("",20);

  AlarmSettings curSettings;

  AlarmInput(String gLabel, AlarmSettings initialSettings) {
    setTitle("Alarm Settings");

    setModal(true);
    setSize(450,350);

    getContentPane().setLayout(new BorderLayout(5,5));

    headerPanel.setLayout(new BorderLayout(1,1));

    headerLabel.setHorizontalAlignment(SwingConstants.LEFT);
    headerLabel2.setHorizontalAlignment(SwingConstants.CENTER);

    if(gLabel != null) {
      headerLabel.setText("Change Alarm Settings for: ");
      headerLabel2.setText(gLabel);
    }
    else {
      headerLabel.setText("Change Alarm Settings");
      headerLabel2.setText(" [process unknown] ");
    }

    headerLabel.setForeground(Color.black);
    headerLabel2.setForeground(Color.red);

    JLabel1.setHorizontalAlignment(SwingConstants.LEFT);
    JLabel1.setText("Alarm Settings:");

    min_label.setText("Min Value: ");
    max_label.setText("Max Value: ");
    thresh_label.setText("Threshold: ");

    min_value.setHorizontalAlignment(JTextField.RIGHT);
    max_value.setHorizontalAlignment(JTextField.RIGHT);
    thresh_value.setHorizontalAlignment(JTextField.RIGHT);

    panel1.setLayout(new BoxLayout(panel1,BoxLayout.Y_AXIS));
    panel2.setLayout(new BoxLayout(panel2,BoxLayout.Y_AXIS));
    panel3.setLayout(new BoxLayout(panel3,BoxLayout.Y_AXIS));
    panel4.setLayout(new BoxLayout(panel4,BoxLayout.Y_AXIS));
    panel5.setLayout(new FlowLayout(FlowLayout.LEFT));
    panel6.setLayout(new FlowLayout(FlowLayout.LEFT));
    panel7.setLayout(new FlowLayout(FlowLayout.LEFT));
    panel8.setLayout(new FlowLayout(FlowLayout.LEFT));

    beep_checkbox.setEnabled(false);
    url_checkbox.setEnabled(false);
    url_value.setEnabled(false);
    chooseFileBtn.setEnabled(false);

    panel1.add(min_label);
    panel1.add(min_value);
    panel2.add(max_label);
    panel2.add(max_value);
    panel3.add(thresh_label);
    panel3.add(thresh_value);
    panel4.add(selectAll_checkbox);

    audioPanel.setLayout(new BoxLayout(audioPanel,BoxLayout.Y_AXIS));
    audioPanel.setBorder(new TitledBorder(new LineBorder(Color.darkGray, 1),
      "Audible Notification Settings"));

    panel7.add(sound_checkbox);

    panel5.add(Box.createHorizontalStrut(15));
    panel5.add(beep_checkbox);

    panel6.add(Box.createHorizontalStrut(15));
    panel6.add(url_checkbox);

    panel8.add(Box.createHorizontalStrut(20));
    panel8.add(url_value);
    panel8.add(chooseFileBtn);

    audioPanel.add(panel7);
    audioPanel.add(panel5);
    audioPanel.add(panel6);
    audioPanel.add(panel8);

    okBtn.setNextFocusableComponent(cancelBtn);
    okBtn.setText("OK");
    okBtn.setActionCommand("OK");

    cancelBtn.setText("Cancel");
    cancelBtn.setActionCommand("Cancel");

    chooseFileBtn.setText("Choose File");
    chooseFileBtn.setActionCommand("choose");

    buttonPanel.setLayout(new FlowLayout(FlowLayout.CENTER,5,5));
    buttonPanel.add(panel4);
    buttonPanel.add(okBtn);
    buttonPanel.add(cancelBtn);

    inputPanel.setLayout(new FlowLayout(FlowLayout.LEFT));

    inputPanel.add(panel1);
    inputPanel.add(panel2);
    inputPanel.add(panel3);

    mainPanel.setLayout(new BorderLayout(3,3));
    mainPanel.add("North", inputPanel);
    mainPanel.add("Center", audioPanel);
    mainPanel.add("South",buttonPanel);

    headerPanel.add("North", headerLabel);
    headerPanel.add("South", headerLabel2);

    getContentPane().add("North", headerPanel);
    getContentPane().add("South", mainPanel);

    if(initialSettings != null) {
      min_value.setText(Double.toString(initialSettings.min));
      max_value.setText(Double.toString(initialSettings.max));
      thresh_value.setText(Integer.toString(initialSettings.thresh));
      sound_checkbox.setSelected(initialSettings.audible);

      if(initialSettings.audible) {
        beep_checkbox.setEnabled(true);
        url_checkbox.setEnabled(true);

        if(initialSettings.sound_url != null) {
          url_checkbox.setSelected(true);
          url_value.setEnabled(true);
          chooseFileBtn.setEnabled(true);
          url_value.setText(initialSettings.sound_url);
        }
        else {
          chooseFileBtn.setEnabled(false);
          url_value.setEnabled(false);
          beep_checkbox.setSelected(true);
        }
      }
    }

    SymAction lSymAction = new SymAction();
    okBtn.addActionListener(lSymAction);
    cancelBtn.addActionListener(lSymAction);
    chooseFileBtn.addActionListener(lSymAction);
    sound_checkbox.addActionListener(lSymAction);
    beep_checkbox.addActionListener(lSymAction);
    url_checkbox.addActionListener(lSymAction);
  }

  public AlarmSettings getSettings() {
    return curSettings;
  }

  public boolean setAll() {
    return selectAll_checkbox.isSelected();
  }

  private void validateSettings() throws IllegalArgumentException {
    StringTokenizer st;

    curSettings = new AlarmSettings();

    try {
      st = new StringTokenizer(min_value.getText());
      curSettings.min = Double.valueOf(st.nextToken()).doubleValue();
    } catch (Exception e) {
      throw new IllegalArgumentException("Error in Min value: " + 
        e.getMessage());
    }

    try {
      st = new StringTokenizer(max_value.getText());
      curSettings.max = Double.valueOf(st.nextToken()).doubleValue();
    } catch (Exception e) {
      throw new IllegalArgumentException("Error in Max value: " + 
        e.getMessage());
    }

    try {
      st = new StringTokenizer(thresh_value.getText());
      curSettings.thresh = Integer.parseInt(st.nextToken());
    } catch (Exception e) {
      throw new IllegalArgumentException("Error in Threshold value: " + 
        e.getMessage());
    }

    if(sound_checkbox.isSelected()) {
      curSettings.audible = true;

      if(beep_checkbox.isSelected()) {
        curSettings.sound_url = null;
      }
      else if(url_checkbox.isSelected()) {
        curSettings.sound_url = url_value.getText();
      }
      else {
        // this case should never be reached
        curSettings.sound_url = null;
      }
    }
    else
      curSettings.audible = false;
  }

  class SymAction implements java.awt.event.ActionListener
  {
    public void actionPerformed(java.awt.event.ActionEvent event)
    {
      Object object = event.getSource();
      if (object == okBtn)
        okBtn_actionPerformed(event);
      else if (object == cancelBtn)
        cancelBtn_actionPerformed(event);
      else if (object == chooseFileBtn)
        chooseFileBtn_actionPerformed(event);
      else if (object == sound_checkbox)
        sound_checkbox_actionPerformed(event);
      else if (object == beep_checkbox)
        beep_checkbox_actionPerformed(event);
      else if (object == url_checkbox)
        url_checkbox_actionPerformed(event);
    }
  }

  void beep_checkbox_actionPerformed(java.awt.event.ActionEvent event)
  {
    url_checkbox.setSelected(false);
    chooseFileBtn.setEnabled(false);
    url_value.setEnabled(false);

    if(!beep_checkbox.isSelected())
      beep_checkbox.setSelected(true);
  }

  void url_checkbox_actionPerformed(java.awt.event.ActionEvent event)
  {
    beep_checkbox.setSelected(false);
    chooseFileBtn.setEnabled(true);
    url_value.setEnabled(true);

    if(!url_checkbox.isSelected())
      url_checkbox.setSelected(true);
  }

  void sound_checkbox_actionPerformed(java.awt.event.ActionEvent event)
  {
    if(sound_checkbox.isSelected()) {
      beep_checkbox.setEnabled(true);
      url_checkbox.setEnabled(true);

      if(!beep_checkbox.isSelected() && !url_checkbox.isSelected())
        beep_checkbox.setSelected(true);
      else if(url_checkbox.isSelected()) {
        chooseFileBtn.setEnabled(true);
        url_value.setEnabled(true);
      }
    }
    else {
      beep_checkbox.setEnabled(false);
      url_checkbox.setEnabled(false);
      chooseFileBtn.setEnabled(false);
      url_value.setEnabled(false);
    }
  }

  void okBtn_actionPerformed(java.awt.event.ActionEvent event)
  {
    try {
      this.validateSettings();
      this.setVisible(false);
    } catch(IllegalArgumentException e) {
      JOptionPane.showMessageDialog(this, e.getMessage());
    }

    return;
  }

  void cancelBtn_actionPerformed(java.awt.event.ActionEvent event)
  {
    this.setVisible(false);

    curSettings = null;

    return;
  }

  void chooseFileBtn_actionPerformed(java.awt.event.ActionEvent event)
  {
    File f;

    try {
      fc.setCurrentDirectory(new File(System.getProperty("user.dir")));
    }catch(Exception e) { }

    fc.setMultiSelectionEnabled(false);

    if(fc.showOpenDialog(this) == JFileChooser.APPROVE_OPTION) {

      f = fc.getSelectedFile();

      try {
        url_value.setText("file:" + f.getCanonicalPath());
      } catch (IOException e) {}
    }
  }

}
