package edu.utk.cs.icl.perfometer.swing_gui;

import edu.utk.cs.icl.perfometer.datatransfer.AlarmSettings;

import edu.utk.cs.icl.perfometer.gui_common.BrowserControl;

import java.awt.*;
import java.text.*;
import java.lang.Float;
import javax.swing.*;
import javax.swing.border.*;

public class ControlsFrame extends JPanel
{
  PerfPanel perfPanel = null;
  final int LINEAR = 0;
  final int LOG = 1;
    
  JPanel topPanel = new JPanel();
  JPanel infoPanel = new JPanel();
  JPanel buttonPanel = new JPanel();
  JPanel labelPanel = new JPanel();
  JPanel mainPanel = new JPanel();

  JLabel JLabel1 = new JLabel();
  JLabel JLabel2 = new JLabel();
  JLabel JLabel3 = new JLabel();
  JLabel JLabel4 = new JLabel();
  JLabel JLabel5 = new JLabel();
  JLabel JLabel6 = new JLabel();
  JLabel JLabel7 = new JLabel();

  JTextField header1JTextField = new JTextField();
  JTextField header2JTextField = new JTextField();

  JButton iclButton = new JButton();
  JButton papiButton = new JButton();
  JButton pauseDisplayButton = new JButton();
  JButton avgButton = new JButton();
  JButton stopDisplayButton = new JButton();
  JButton threshButton = new JButton();
  JButton logLinearSwitchButton = new JButton();

  ImageIcon imageIcon1;
  ImageIcon imageIcon2;

  JComboBox graphTypeChoice = new JComboBox();

  String l1, l2, l3, l4, l5, l6;
  String u1, u2, u3, u4, u5, u6;
  String v1, v2, v3, v4, v5, v6;

  NumberFormat nformat;
  
  public ControlsFrame(PerfPanel p)
  {
    this.perfPanel = p;
    setSize(787,134);
    setLayout(new BorderLayout(5,5)); 

    mainPanel.setLayout(new BoxLayout(mainPanel, BoxLayout.Y_AXIS));

    nformat = NumberFormat.getInstance();
    nformat.setGroupingUsed(true);
    nformat.setMaximumFractionDigits(2);

    try {
      imageIcon1 = new ImageIcon(Perfometer.class.getClassLoader().getResource("./images/UT-ICL.gif"));
      imageIcon2 = new ImageIcon(Perfometer.class.getClassLoader().getResource("./images/papitrans2.gif"));
    } catch (Exception icon_exc) {}

    this.setPreferredSize(this.getSize());

    header1JTextField.setEditable(false);
    header1JTextField.setDisabledTextColor(java.awt.Color.black);
    header1JTextField.setBackground(java.awt.Color.white);
    header1JTextField.setFont(new Font("Dialog", Font.PLAIN, 12));

    header2JTextField.setEditable(false);
    header2JTextField.setBackground(java.awt.Color.white);
    header2JTextField.setFont(new Font("Dialog", Font.PLAIN, 12));

    infoPanel.setLayout(new BoxLayout(infoPanel,BoxLayout.Y_AXIS));
    infoPanel.add(header1JTextField);
    infoPanel.add(header2JTextField);

    iclButton.setBorderPainted(false);
    iclButton.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
    iclButton.setActionCommand("iclLogoButton");
    iclButton.setVisible(true);
    iclButton.setIcon(imageIcon1);

    papiButton.setBorderPainted(false);
    papiButton.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
    papiButton.setActionCommand("papiLogoButton");
    papiButton.setVisible(true);
    papiButton.setIcon(imageIcon2);

    topPanel.setLayout(new BorderLayout(5,5));
    topPanel.add(BorderLayout.CENTER, infoPanel);
    topPanel.add(BorderLayout.EAST, iclButton);

    JLabel6.setHorizontalTextPosition(javax.swing.SwingConstants.LEFT);
    JLabel6.setFont(new Font("Dialog", Font.BOLD, 11));

    labelPanel.setLayout(new GridLayout(2,3));
    labelPanel.add(JLabel1);
    labelPanel.add(JLabel3);
    labelPanel.add(JLabel4);
    labelPanel.add(JLabel2);
    labelPanel.add(JLabel6);
    labelPanel.add(JLabel5);

    stopDisplayButton.setText(" Stop Datastream");
    stopDisplayButton.setActionCommand("Stop");
    stopDisplayButton.setMnemonic((int)'S');
    stopDisplayButton.setFont(new Font("Dialog", Font.PLAIN, 12));

    threshButton.setText("Set Alarm");
    threshButton.setActionCommand("thresh");
    threshButton.setMnemonic((int)'T');
    threshButton.setFont(new Font("Dialog", Font.PLAIN, 12));
    
    pauseDisplayButton.setText(" Pause App");
    pauseDisplayButton.setActionCommand("Pause");
    pauseDisplayButton.setMnemonic((int)'P');
    pauseDisplayButton.setFont(new Font("Dialog", Font.PLAIN, 12));

    avgButton.setText("Disable Avg Plot");
    avgButton.setActionCommand("avg");
    avgButton.setMnemonic((int)'A');
    avgButton.setFont(new Font("Dialog", Font.PLAIN, 12));

    JLabel7.setText("Graph Type:");

    graphTypeChoice.addItem(Perfometer.PAPI_BARGRAPH);
    graphTypeChoice.addItem(Perfometer.PAPI_XYSCATTER);
    graphTypeChoice.addItem(Perfometer.PAPI_LINEGRAPH);
    graphTypeChoice.addItem(Perfometer.PAPI_LINEGRAPHWITHPOINTS);
    graphTypeChoice.addItem(Perfometer.PAPI_FILLEDLINE);
    graphTypeChoice.setSelectedItem(Perfometer.PAPI_FILLEDLINE);
    graphTypeChoice.setVisible(true);

    logLinearSwitchButton.setToolTipText("Switch between log and linear scales.");
    logLinearSwitchButton.setText("Linear");
    logLinearSwitchButton.setActionCommand("Pause");
    logLinearSwitchButton.setMnemonic((int)'L');
    logLinearSwitchButton.setFont(new Font("Dialog", Font.PLAIN, 12));
    logLinearSwitchButton.setVisible(false);

    buttonPanel.setLayout(new FlowLayout(FlowLayout.LEFT,5,5));
    buttonPanel.add(pauseDisplayButton);
    buttonPanel.add(stopDisplayButton);
    buttonPanel.add(threshButton);
    buttonPanel.add(avgButton);
    buttonPanel.add(JLabel7);
    buttonPanel.add(graphTypeChoice);
    buttonPanel.add(logLinearSwitchButton);

    mainPanel.add(topPanel);
    mainPanel.add(labelPanel);
    mainPanel.add(buttonPanel);
    		
    add(BorderLayout.CENTER, mainPanel);
    add(BorderLayout.EAST, papiButton);

    SymAction lSymAction = new SymAction();
    pauseDisplayButton.addActionListener(lSymAction);
    avgButton.addActionListener(lSymAction);
    stopDisplayButton.addActionListener(lSymAction);
    threshButton.addActionListener(lSymAction);
    logLinearSwitchButton.addActionListener(lSymAction);
    iclButton.addActionListener(lSymAction);
    papiButton.addActionListener(lSymAction);
    graphTypeChoice.addActionListener(lSymAction);
  }

  public void setPauseEnabled(boolean x) {
    pauseDisplayButton.setEnabled(x);
  }

  public void setStopEnabled(boolean x) {
    stopDisplayButton.setEnabled(x);
  }

  public void setAlarmEnabled(boolean x) {
    threshButton.setEnabled(x);
  }

  public void setLabels(String h1, String h2, String l1, String l2, String l3, String l4,
    String l5, String l6)
  {
    header1JTextField.setText(h1);
    header2JTextField.setText(h2);
    this.l1 = l1;
    this.l2 = l2;
    this.l3 = l3;
    this.l4 = l4;
    this.l5 = l5;
    this.l6 = l6;

    JLabel1.setText(this.l1 + "  " + v1 + "  " + u1);
    JLabel2.setText(this.l2 + "  " + v2 + "  " + u2);
    JLabel3.setText(this.l3 + "  " + v3 + "  " + u3);
    JLabel4.setText(this.l4 + "  " + v4 + "  " + u4);
    JLabel5.setText(this.l5 + "  " + v5 + "  " + u5);
    JLabel6.setText(this.l6 + "  " + v6 + "  " + u6);
  }

  public void setUnits(String l1, String l2, String l3, String l4, String l5, String l6) {
    u1 = l1; u2 = l2; u3 = l3; u4 = l4; u5 = l5; u6 = l6;

    JLabel1.setText(this.l1 + "  " + v1 + "  " + u1);
    JLabel2.setText(this.l2 + "  " + v2 + "  " + u2);
    JLabel3.setText(this.l3 + "  " + v3 + "  " + u3);
    JLabel4.setText(this.l4 + "  " + v4 + "  " + u4);
    JLabel5.setText(this.l5 + "  " + v5 + "  " + u5);
  }
   	
  public void setValues(String l1, String l2, String l3, String l4, String l5, String l6) {
    String vl1 = l1, vl2 = l2, vl3 = l3, vl4 = l4, vl5 = l5, vl6 = l6;
    v1 = l1; v2 = l2; v3 = l3; v4 = l4; v5 = l5; v6 = l6;
        
    if(!l1.equals("")) vl1 = nformat.format(Double.valueOf(l1).doubleValue());
    if(!l2.equals("")) vl2 = nformat.format(Double.valueOf(l2).doubleValue());
    if(!l3.equals("")) vl3 = nformat.format(Double.valueOf(l3).doubleValue());
    if(!l4.equals("")) vl4 = nformat.format(Double.valueOf(l4).doubleValue());
    if(!l5.equals("")) vl5 = nformat.format(Double.valueOf(l5).doubleValue());
    if(!l6.equals("")) vl6 = nformat.format(Double.valueOf(l6).doubleValue());
 
    JLabel1.setText(this.l1 + "  " + vl1 + "  " + u1);
    JLabel2.setText(this.l2 + "  " + vl2 + "  " + u2);
    JLabel3.setText(this.l3 + "  " + vl3 + "  " + u3);
    JLabel4.setText(this.l4 + "  " + vl4 + "  " + u4);
    JLabel5.setText(this.l5 + "  " + vl5 + "  " + u5);
    JLabel6.setText(this.l6 + "  " + vl6 + "  " + u6);
  }

  class SymAction implements java.awt.event.ActionListener
  {
    public void actionPerformed(java.awt.event.ActionEvent event)
    {
      Object object = event.getSource();
      Perfometer p = Perfometer.getInstance();

      p.setDrawingDelay(GraphUpdateThread.VERY_SLOW);

      if (object == pauseDisplayButton)
        pauseDisplayButton_actionPerformed(event);
      else if (object == avgButton)
        avgButton_actionPerformed(event);
      else if (object == stopDisplayButton)
        stopDisplayButton_actionPerformed(event);
      else if (object == threshButton)
        threshButton_actionPerformed(event);
      else if (object == logLinearSwitchButton)
        logLinearSwitchButton_actionPerformed(event);
      else if (object == iclButton)
        iclButton_actionPerformed(event);
      else if (object == papiButton)
        papiButton_actionPerformed(event);
      else if (object == graphTypeChoice)
        graphTypeChoice_actionPerformed(event);

      p.setDrawingDelay(GraphUpdateThread.FAST);
    }
  }

  void avgButton_actionPerformed(java.awt.event.ActionEvent event)
  {
    boolean avg_status = perfPanel.getAvgEnabled();

    perfPanel.setAvgEnabled(!avg_status);

    if(avg_status)
      avgButton.setText("Enable Avg Plot");
    else
      avgButton.setText("Disable Avg Plot");
  }

  void pauseDisplayButton_actionPerformed(java.awt.event.ActionEvent event)
  {
    boolean paused_status = perfPanel.isPaused();

    perfPanel.setPaused(!paused_status);

    if(paused_status) 
      pauseDisplayButton.setText(" Pause App");
    else
      pauseDisplayButton.setText("Resume App");
  }

  void threshButton_actionPerformed(java.awt.event.ActionEvent event)
  {
    AlarmInput i = new AlarmInput(perfPanel.getGraphLabel(),
       perfPanel.getAlarmSettings());

    i.setLocation(getX() + 30, getY() + 30);
    i.show();

    AlarmSettings s = i.getSettings();
 
    if(s != null) {
      if(i.setAll())
        Perfometer.getInstance().setAllAlarms(s);
      else
        perfPanel.setAlarmSettings(s);
    }
  }

  void stopDisplayButton_actionPerformed(java.awt.event.ActionEvent event)
  {
    boolean stopped_status = perfPanel.isStopped();

    perfPanel.setStopped(!stopped_status);

    if(stopped_status) 
      stopDisplayButton.setText(" Stop Datastream");
    else
      stopDisplayButton.setText("Start Datastream");
  }

  void logLinearSwitchButton_actionPerformed(java.awt.event.ActionEvent event)
  {
    if (logLinearSwitchButton.getText().compareToIgnoreCase("Linear") == 0) {
      perfPanel.setLogLinearScale(LOG);
      logLinearSwitchButton.setText("Log");
    } else {
      perfPanel.setLogLinearScale(LINEAR);
      logLinearSwitchButton.setText("Linear");
    }	    
  }

  void papiButton_actionPerformed(java.awt.event.ActionEvent event)
  {
    BrowserControl.displayURL("http://icl.cs.utk.edu/papi");
  }

  void iclButton_actionPerformed(java.awt.event.ActionEvent event)
  {
    BrowserControl.displayURL("http://icl.cs.utk.edu");
  }

  void graphTypeChoice_actionPerformed(java.awt.event.ActionEvent event)
  {
    perfPanel.setGraphType(graphTypeChoice.getSelectedIndex());
  }
}
