package edu.utk.cs.icl.perfometer.swing_gui;

import edu.utk.cs.icl.perfometer.metrics.*;
import java.awt.Toolkit.*;
import java.awt.*;
import javax.swing.*;
import javax.swing.border.*;

public class InputBox extends JDialog
{
  String hostname = "";
  int portNum = -1;

  JPanel mainPanel = new JPanel();
  JPanel hostPortPanel = new JPanel();
  JPanel buttonPanel = new JPanel();
  JPanel metricPanel = new JPanel();

  JTextField hostnameTxt = new JTextField(20);
  JTextField portNumTxt = new JTextField(5);

  JTextArea instrText = new JTextArea();

  JLabel hostnameLabel = new JLabel();
  JLabel portnumLabel = new JLabel();
  JLabel metricselLabel = new JLabel();

  TitledBorder titledBorder1 = new TitledBorder(new LineBorder(Color.gray, 2),
      "Enter the host name and port number of the machine to connect to:");

  JButton okBtn = new JButton();
  JButton cancelBtn = new JButton();

  JComboBox metricSel = new JComboBox();

  public InputBox(Frame owner, String title, MetricParser[] mparr) {
    this(owner, title, "localhost", mparr);
  }

  public InputBox(Frame owner, String title, String initialHostname, 
     MetricParser[] mparr)
  {
    super(owner, title, true);
    hostnameTxt.setText(initialHostname);
    setModal(true);
    getContentPane().setLayout(new BorderLayout(0,0));
    setSize(559,170);
    setVisible(false);
    
    for(int i=0;i<mparr.length;i++)
      metricSel.addItem(mparr[i]);

    hostnameLabel.setHorizontalAlignment(SwingConstants.RIGHT);
    hostnameLabel.setText("Host Name:");
    portnumLabel.setHorizontalAlignment(SwingConstants.RIGHT);
    portnumLabel.setText("Port Number:");
    metricselLabel.setHorizontalAlignment(SwingConstants.RIGHT);
    metricselLabel.setText("Choose Metric:");

    instrText.setText("The port number is 3545 by default, only change this if the server displayed a different number when it was started.");
    instrText.setOpaque(false);
    instrText.setEditable(false);
    instrText.setLineWrap(true);
    instrText.setWrapStyleWord(true);

    portNumTxt.setNextFocusableComponent(okBtn);
    portNumTxt.setText("3545");

    metricPanel.setLayout(new FlowLayout(FlowLayout.LEFT));
    metricPanel.add(metricselLabel);
    metricPanel.add(metricSel);

    hostPortPanel.setLayout(new FlowLayout(FlowLayout.LEFT));
    hostPortPanel.add(hostnameLabel);
    hostPortPanel.add(hostnameTxt);
    hostPortPanel.add(portnumLabel);
    hostPortPanel.add(portNumTxt);

    mainPanel.setBorder(titledBorder1);
    mainPanel.setLayout(new BorderLayout(5,5));
    mainPanel.add("North",hostPortPanel);
    mainPanel.add("Center", instrText);

    okBtn.setNextFocusableComponent(cancelBtn);
    okBtn.setText("OK");
    okBtn.setActionCommand("OK");

    cancelBtn.setText("Cancel");
    cancelBtn.setActionCommand("Cancel");

    buttonPanel.setLayout(new BoxLayout(buttonPanel, BoxLayout.X_AXIS));
    buttonPanel.add(metricPanel);
    buttonPanel.add(okBtn);
    buttonPanel.add(cancelBtn);

    getContentPane().add(BorderLayout.CENTER,mainPanel);
    getContentPane().add(BorderLayout.SOUTH,buttonPanel);

    SymAction lSymAction = new SymAction();
    okBtn.addActionListener(lSymAction);
    cancelBtn.addActionListener(lSymAction);
  }
	
  public void setHostname(String h) {
    hostnameTxt.setText(h);
    portNumTxt.setText("3545");
  }

  public String getHostname() {
    return hostname;
  }

  public MetricParser getSelectedMetric() {
    return (MetricParser) metricSel.getSelectedItem();
  }

  class SymAction implements java.awt.event.ActionListener
  {
    public void actionPerformed(java.awt.event.ActionEvent event)
    {
      Object object = event.getSource();
      if (object == okBtn)
        okBtn_actionPerformed(event);
      else if (object == cancelBtn)
        cancelBtn_actionPerformed(event);
    }
  }

  void okBtn_actionPerformed(java.awt.event.ActionEvent event)
  {
    try {
      portNum = Integer.parseInt(portNumTxt.getText());
    } catch(NumberFormatException e) {;}

    if ((hostnameTxt.getText().compareToIgnoreCase("") != 0) && (portNum != -1)) {
      hostname = this.hostnameTxt.getText();
      this.hostnameTxt.setText("");
      this.portNumTxt.setText("");
      this.setVisible(false);
      return;
    } else {
      Toolkit.getDefaultToolkit().beep();
    }
  }

  void cancelBtn_actionPerformed(java.awt.event.ActionEvent event)
  {
    hostname = null;
    this.hostnameTxt.setText("");
    this.portNumTxt.setText("");
    this.setVisible(false);
    return;
  }
}
