package edu.utk.cs.icl.perfometer.swing_gui;

import edu.utk.cs.icl.perfometer.metrics.MetricParser;

import edu.utk.cs.icl.perfometer.event.GraphLegendListener;
import edu.utk.cs.icl.perfometer.event.GraphLegendEvent;

import java.util.*;
import java.awt.Toolkit.*;
import java.awt.*;
import javax.swing.*;
import javax.swing.border.*;

public class LegendFrame extends JFrame implements GraphLegendListener
{
/*
 *JPanel headerPanel = new JPanel();
 *JLabel min_label = new JLabel();
 *JTextField min_value =    new JTextField("0.0",8);
 */

  JButton cancelBtn = new JButton("Close");
  JPanel mainpanel = new JPanel();
  JScrollPane mainscroll;
  MetricParser metric;

  LegendFrame(MetricParser m) {
    setTitle("Legend");
    metric = m;

    setSize(220,210);
 
    getContentPane().setLayout(new BorderLayout(5,5));
    mainpanel.setLayout(new BoxLayout(mainpanel, BoxLayout.Y_AXIS));
    mainscroll = new JScrollPane(mainpanel);

    initializeList();
    
    SymAction lSymAction = new SymAction();

    cancelBtn.addActionListener(lSymAction);

    getContentPane().add(BorderLayout.CENTER, mainscroll);
    getContentPane().add(BorderLayout.SOUTH, cancelBtn);

    metric.addGraphLegendListener(this);
  }

  private void initializeList() {
    Enumeration labels, colors;

    labels = metric.getAllLabels();
    colors = metric.getAllColors();

    while(labels.hasMoreElements()) {
      addLabel((String)colors.nextElement(), (String)labels.nextElement()); 
    }
  }

  private void addLabel(String color, String label) {
    JPanel newpanel = new JPanel();
    newpanel.setLayout(new FlowLayout(FlowLayout.LEFT));

    JLabel l = new JLabel(label);
    JButton b = new JButton();
    b.setBackground(Color.decode(color));

    newpanel.add(b); 
    newpanel.add(l);
    mainpanel.add(newpanel);
  }

  public void labelAdded(GraphLegendEvent e) {
    addLabel(Integer.toString(e.getColor()), e.getLabel());

    mainscroll.validate();
  }

  class SymAction implements java.awt.event.ActionListener
  {
    public void actionPerformed(java.awt.event.ActionEvent event)
    {
      Object object = event.getSource();
      if (object == cancelBtn)
        cancelBtn_actionPerformed(event);
    }
  }

  void cancelBtn_actionPerformed(java.awt.event.ActionEvent event)
  {
    metric.removeGraphLegendListener(this);
    setVisible(false);
  }
}
