package edu.utk.cs.icl.perfometer.swing_gui;

import edu.utk.cs.icl.perfometer.datatransfer.PerfMetric;

import javax.swing.*;
import javax.swing.border.*;
import java.awt.*;

public class LowLevelMetricSelectionDialog extends JDialog
{
  PerfMetric[] eventList;
  PerfMetric selectedMetric = null;
    
  JPanel buttonPanel = new JPanel();
  JPanel instructionPanel = new JPanel();
  JPanel listPanel = new JPanel();

  JTextArea instrPane = new JTextArea();

  JList availEventList;

  JButton okBtn = new JButton();
  JButton CancelBtn = new JButton();

  TitledBorder titledBorder1 = new TitledBorder(new LineBorder(Color.gray, 2), "Metric Selection");
  TitledBorder titledBorder5 = new TitledBorder(new LineBorder(Color.gray, 2), "Metric to be displayed");

  String instructions = "The PAPI metrics that can be monitored on your application are shown below under available metrics.  Please select the metric to be shown on the graph, then select the metrics that will be displayed as text.";

  public LowLevelMetricSelectionDialog(PerfMetric[] el) {
    eventList = el;
        
    setTitle("Metric Selection");
    setSize(626, 300);
    setModal(true);
    getContentPane().setLayout(new BorderLayout(5,5));

    availEventList = new JList(new DefaultListModel());

    JScrollPane availScrollPane = new JScrollPane(availEventList);

    okBtn.setText("OK");
    okBtn.setActionCommand("OK");

    CancelBtn.setText("Cancel");
    CancelBtn.setActionCommand("Cancel");

    buttonPanel.setLayout(new FlowLayout(FlowLayout.RIGHT,5,5));
    buttonPanel.add(okBtn);
    buttonPanel.add(CancelBtn);

    listPanel.setBorder(titledBorder5);
    listPanel.setLayout(new BoxLayout(listPanel, BoxLayout.Y_AXIS));
    listPanel.add(availScrollPane);

    instrPane.setText(instructions);
    instrPane.setOpaque(false);
    instrPane.setEditable(false);
    instrPane.setLineWrap(true);
    instrPane.setWrapStyleWord(true);

    instructionPanel.setBorder(titledBorder1);
    instructionPanel.setLayout(new BoxLayout(instructionPanel, BoxLayout.Y_AXIS));
    instructionPanel.add(instrPane);

    getContentPane().add(BorderLayout.NORTH, instructionPanel);
    getContentPane().add(BorderLayout.CENTER, listPanel);
    getContentPane().add(BorderLayout.SOUTH,buttonPanel);

    setupLists();
            
    SymAction lSymAction = new SymAction();
    okBtn.addActionListener(lSymAction);
    CancelBtn.addActionListener(lSymAction);
  }

  public PerfMetric getSelectedMetric() {
    return selectedMetric;
  }

  void setupLists() {
    PerfMetric e;
    DefaultListModel listModel = (DefaultListModel) availEventList.getModel();

    for(int i = 0; i < eventList.length; i++) {
      e = eventList[i];
      if(e != null)
        listModel.addElement(e);
    }
  }
        
  class SymAction implements java.awt.event.ActionListener
  {
    public void actionPerformed(java.awt.event.ActionEvent event)
    {
      Object object = event.getSource();

      if (object == CancelBtn)
        CancelBtn_actionPerformed(event);
      else if (object == okBtn)
        okBtn_actionPerformed(event);
    }
  }

  void CancelBtn_actionPerformed(java.awt.event.ActionEvent event)
  {
    selectedMetric = null;
    this.setVisible(false);
    return;
  }

  void okBtn_actionPerformed(java.awt.event.ActionEvent event)
  {
    selectedMetric = (PerfMetric) availEventList.getSelectedValue();
    this.setVisible(false);
    return;
  }

}

